import pygame
import math
import random

def inicializuj_kulicky(kolik, barvy_kulicek):
    def inicializuj_kulicku_nahodne(sirka, vyska, barvy):
        pozice_x = random.randint(10,sirka-10) # náhodná x-ová souřadnice
        pozice_y = random.randint(10,vyska-10) # náhodná y-ová souřadnice
        rychlost_x = random.random() - 0.5 # náhodný vektor rychlosy vx,vy
        rychlost_y = random.random() - 0.5
        barva = barvy[random.randint(0,len(barvy)-1)] # náhodná barva
        polomer = 40
        return kulicka(pozice_x, pozice_y, rychlost_x, rychlost_y, barva, polomer)
    sirka, vyska = pygame.display.get_surface().get_size()
    return [ inicializuj_kulicku_nahodne(sirka, vyska, barvy_kulicek) for i in range(kolik)]



class kulicka(object):
    def __init__(self, pozice_x, pozice_y, rychlost_x, rychlost_y, barva, polomer):
        self._pozice_x = pozice_x
        self._pozice_y = pozice_y
        self._rychlost_x = rychlost_x
        self._rychlost_y = rychlost_y
        self._barva = barva
        self._polomer = polomer
        self._ziva = True

    @property
    def x(self):
        return self._pozice_x
    @property
    def y(self):
        return self._pozice_y
    @property
    def vx(self):
        return self._rychlost_x
    @property
    def vy(self):
        return self._rychlost_y
    @property
    def barva(self):
        return self._barva
    @property
    def polomer(self):
        return self._polomer
    @property
    def levy_okraj(self):
        return self._pozice_x - self._polomer
    @property
    def pravy_okraj(self):
        return self._pozice_x + self._polomer
    @property
    def dolni_okraj(self):
        return self._pozice_y - self._polomer
    @property
    def horni_okraj(self):
        return self._pozice_y + self._polomer

    @property
    def ziva(self):
        return self._ziva

    def posun(self, sirka, vyska, dt):
        self._pozice_x = self._pozice_x + self._rychlost_x * dt
        self._pozice_y = self._pozice_y + self._rychlost_y * dt
        #reseni odrazu od kraju
        if self.levy_okraj <= 0 or self.pravy_okraj >= sirka:
            self._rychlost_x *= -1
        if self.dolni_okraj <= 0 or self.horni_okraj >= vyska :
            self._rychlost_y *= -1

    def nakresli_se(self, okno, font):
        pygame.draw.circle(okno,self.barva,(int(self.x),int(self.y)),int (self._polomer))

    def kontrola_srazky(self, kulicky):
        for kulicka in kulicky:
            if not kulicka is self and kulicka._ziva:
                vzdalenost = math.sqrt( (self.x-kulicka.x)**2 +(self.y-kulicka.y)**2)
                if vzdalenost < self.polomer and kulicka.polomer <= self._polomer:
                    kulicka._ziva = False
                    self._polomer *= 1.2
