"""
Simulace pohybu kuliček s náhodným počátečním vektorem rychlosti.
V úloze jsou řešeny i odrazy od stěn.

Slouží pro ilustraci objektů a her pomocí Pygame

Použit zvuk z https://www.freesoundeffects.com/free-sounds/swamp-10012/
"""
import pygame
import objekty
import nastaveni


pygame.init()
sirka = 1000
vyska = 1000
rozmery = [sirka, vyska]
pygame.display.set_caption("Uklidněte se a zhluboka dýchejte")
okno = pygame.display.set_mode(rozmery) # vytvoř okno hry
font = pygame.font.SysFont("None", 14)  #vytvoř/použij  systémový font
clock = pygame.time.Clock() #vytvoř objekt hodin
barvy_kulicek = [(255,0,0),(0,255,0),(0,0,255), (255,255,0)]
barva_pozadi = (255,255,255) # bila barva pozadí
dt = 4# velikost časového kroku, ovlivňuje velikost posunu po obrazovce
pocet_kulicek = 10

# predpoklada se inicializace pygame
kulicky = objekty.inicializuj_kulicky(pocet_kulicek, barvy_kulicek)


beh = True #pomocná proměnná pro kontrolu běhu programu
pygame.mixer.music.load('water-swamp.mp3')
pygame.mixer.music.play(-1) # prehravej dokola
while beh: # cyklus hry

    for event in pygame.event.get(): #obsluha událostí hry
        if event.type == pygame.QUIT: # kliknutí na křížek na okně
            beh = False

    keys_pressed = pygame.key.get_pressed() #zjištění informace o stisklé klávese
    if keys_pressed[pygame.K_RETURN]: #ukončení stiskem enter
        beh=False


    okno.fill(barva_pozadi) # překresli barvou pozadí, smaže se staré
    for kulicka in kulicky:
        kulicka.posun(sirka, vyska,dt) # posun kulicku
        kulicka.nakresli_se(okno, font) # nakresli kulicku
        #kulicka.kontrola_srazky(kulicky) # otestuj srazku s dalsimi

    pygame.display.update() #vykreslení okna na obrazovku
    clock.tick(30) #30 fps, pozastavení cyklu while

pygame.quit()
quit()
