"""
Implementace kontroly závorek pomocí zásobníku implementovaná v Pythonu.
Algoritmus dává každou otevírací závorku na zásobník, v případě nalezení uzavírací
závorky v textu, odebírá ze zásobníku a kontroluje zda jsou závorky párové.
Pokud ne, nebo je zásobník prázdný je chyba. Na konci musí být zásobník prázdný.
Informace o párovosti závorek je uložena ve slovníku.

Příklad vhodný pro procvičení pojmu zásobník a jeho aplikace.

Studenti mohou funkci upravit tak, aby docházelo k výpisu kde chyba nastala.
"""


def kontrola_zavorek(vyraz):
    """Funkce pro kontrolu závorek pomocí zásobníku."""
    zavorky = {"[":1,"]":-1,"(":2,")":-2,"<":3,">":-3,"{":4,"}":-4}
    zasobnik = []# prázdný seznam
    for znak in vyraz:
        hodnota = zavorky.get(znak,0) # pokud není ve slovníku, je to 0, tj. znak není závorkou
        if hodnota > 0:#je to otevírací závorka
            zasobnik.append(hodnota)
        elif hodnota <0:#zavírací závorka
            if len(zasobnik) == 0 or zasobnik.pop()+hodnota != 0:
                return False
    return True if len(zasobnik) == 0 else False



vyraz = "<a+3*(a+b)-4>"

print("Kontrola zavorek vyrazu: {0} je uspesna: {1}".format(vyraz, kontrola_zavorek(vyraz)))
