"""
Příklady pro rozšíření pojmu objekt
Důraz klademe na vlastní experimenty studentů, kteří by si měli vyzkoušet,
vypsat informace o různých objektech.

Můžeme navíc v přehledu metod řetězců str ilustrovat metodu str.format(),
která je často použita.

"""
import datetime
import inspect

#Pomocná metoda, není nutno vysvětlovat.
#Použita jednoduchá reflexe pro výpis informací.
def vypis_informace(instance):
    """Funkce pro jednoduchou reflexi.
    Vypisuje informace o instanci na vstupu.
    """
    def radek():
        print("-"*20)
    print("Na vstupu je {0}".format(type(instance)))
    print("Hodnota je {0}".format(repr(instance)))
    radek()
    for jmeno, hodnota in inspect.getmembers(instance):
        if jmeno.startswith("_"):
            print("Privátní {0}:{1}".format(jmeno,hodnota))
        else:
            print("Veřejné {0}:{1}".format(jmeno,hodnota))
    radek()
    radek()

#Seznámení s tím, že "4" je vlastně instance třídy str
vypis_informace("4")
input("Stiskni libovolnou klávesu")
#I hodnota obsažená v proměnné dnes je instancí třídy datetime.
#Můžeme ukázat použití vlastností datetime
dnes = datetime.datetime
vypis_informace(dnes)
input("Stiskni libovolnou klávesu")

#Taktéž seznam čísel je objektem
vypis_informace([1,2,3,4])
input("Stiskni libovolnou klávesu")

#I funkce vypis_informace je v Pythonu objektem a má své atributy.
vypis_informace(vypis_informace)
input("Stiskni libovolnou klávesu")
